/******************************************************************************/
/* Files to Include                                                           */
/******************************************************************************/

#include <htc.h>
#include "user.h"

/******************************************************************************/
/* User Functions                                                             */
/******************************************************************************/

void Delay(){
	unsigned int i = 10000;
	while(i--);
}
char RecieveAddressI2C(void){
	char data = 0;
	short i;
	//START CONDITION
	while(SDA_PORT && SCL_PORT);
	if(SCL_PORT && !SDA_PORT) {
		//START
		while(SCL_PORT);
		for(i = 0; i < 8; i++){
		while(!SCL_PORT);
		data |= SDA_PORT & 0x01;
		if(i != 7) data << = 1;
		while(SCL_PORT);

		}
		if(data == ADDRESS){
			SDA_TRIS = 0;
			while(!SCL_PORT);
			while(SCL_PORT);
			SDA_TRIS = 1;
		}
		else{
			while(!SCL_PORT);
			while(SCL_PORT);
		}

	}
		while(!(SDA_PORT && SCL_PORT));
		if(data == ADDRESS) return 1;
		else return 0;

}
char RecieveCommandI2C(void){
	char command = 0;
	short i;
	//START CONDITION
	while(SDA_PORT && SCL_PORT);
	if(SCL_PORT && !SDA_PORT) {
		//START
		while(SCL_PORT);
		for(i = 0; i < 8; i++){
		while(!SCL_PORT);
		command |= SDA_PORT & 0x01;
		if(i != 7) command << = 1;
		while(SCL_PORT);

		}
		SDA_TRIS = 0;
		while(!SCL_PORT);
		while(SCL_PORT);
		SDA_TRIS = 1;



	}
		while(!(SDA_PORT && SCL_PORT));
		return command;


}
char ReadFlash(){
	char data = 0;
	PMADRL = 0x00;
	PMADRH = 0x06;
	PMCON1bits.CFGS = 0;
	PMCON1bits.RD = 1;
	Nop();
	Nop();

	data = PMDATL;
	return data;
}
void EraseFlash(){
	GIE = 0;
	PMADRL = 0x00;
	PMADRH = 0x06;
	PMCON1bits.CFGS = 0;
	PMCON1bits.FREE = 1;
	PMCON1bits.WREN = 1;
	UnlockFlash();
	PMCON1bits.WREN = 0;
	GIE = 1;
}
void UnlockFlash(){
	PMCON2 = 0x55;
	PMCON2 = 0xAA;
	PMCON1bits.WR = 1;
	Nop();
	Nop();
}
void WriteFlash(short data, short address){
	GIE = 0;
	PMCON1bits.CFGS = 0;
	PMADRL = address & 0x00FF;
	address >>= 8;
	PMADRH = address & 0x00FF;
	PMCON1bits.FREE = 0;
	PMCON1bits.LWLO = 1;
	PMCON1bits.WREN = 1;
	PMDATL = data & 0x00FF;
	data >>= 8;
	PMDATH = data & 0x00FF;
	PMCON1bits.LWLO = 0;
	UnlockFlash();
	PMCON1bits.WREN = 0;
	GIE = 1;
}
void InitApp(void){


	ANSELA = 0;
	ANSELC = 0;
	JMP_TRIS = 1;
	SDA_TRIS = 1;
	SCL_TRIS = 1;
	TRISAbits.TRISA5 = 1;
	TRISCbits.TRISC5 = 0;

 
	/*CLC Setup*/
	APFCONbits.CLC1SEL = 1;
	NCO1CLKbits.N1CKS = 11;
	NCO1CONbits.N1EN = 1;


// File: CLC2.inc
// Generated by CLC Designer, Version: 1.0.0.3
// Date: 21/04/2012 11:05
// Device:PIC16(L)F1503

	CLC1GLS0 = 0x02;
	CLC1GLS1 = 0x00;
	CLC1GLS2 = 0x00;
	CLC1GLS3 = 0x00;
	CLC1SEL0 = 0x01;
	CLC1SEL1 = 0x00;
	CLC1POL  = 0x02;
	CLC1CON  = 0x40;

	CLC2GLS0 = 0x02;
	CLC2GLS1 = 0x00;
	CLC2GLS2 = 0x00;
	CLC2GLS3 = 0x00;
	CLC2SEL0 = 0x01;
	CLC2SEL1 = 0x00;
	CLC2POL  = 0x02;
	CLC2CON  = 0x40;

}

